/*
*	system
*
*	Nicholas Christopoulos
*/

#if !defined(_sb_sys_h)
#define _sb_sys_h

#if defined(__cplusplus)
extern "C" {
#endif

#if defined(_PalmOS)
	#include <PalmOS.h>
	#include <PalmCompatibility.h>
	#include <string.h>
	#include "mathlib.h"
#else
	#include <stdio.h>
	#include <stdlib.h>
	#include <math.h>
	#include <math.h>
	#include <time.h>
	#if defined(_UnixOS)
		#include <unistd.h>
	#else
		#include <io.h>
	#endif
	#include <sys/stat.h>
	#include <fcntl.h>
#endif
#if defined(_BCB_W32_IDE)
	#include "win32/bcb.h"
#endif

#define	SB_STR_VER		"0.6.0"
#define	SB_DWORD_VER	0x600

#define	MAX_TEXT_LINE	256

#if defined(_PalmOS)
	#define	SEC(x)	__attribute__((section(#x)))
#else
	#define	SEC(x)	
#endif

#include "pmem.h"

#if defined(_UnixOS)	// __i386__
	#define	BS16(x)	((((x) >> 8) & 0xff) | (((x) & 0xff) << 8))
	#define	BS32(x)	((((x) & 0xff000000) >> 24) | (((x) & 0x00ff0000) >>  8) | (((x) & 0x0000ff00) <<  8) | (((x) & 0x000000ff) << 24))

#else
	#define	BS16(x)	(x)
	#define	BS32(x)	(x)
#endif

#define	ABS(x)	( ((x) < 0) ? -(x) : (x) )

#if defined(__cplusplus)
}
#endif

#endif



